package org.mai.dep810.spark

import org.apache.spark.sql.SparkSession
import com.databricks.spark.xml._

import org.log4s._

object XmlConverter {

  val appName: String = "XmlConverter"

  private[this] val logger = getLogger

  def main(args: Array[String]): Unit ={

    org.apache.log4j.LogManager.getLogger("com").setLevel(org.apache.log4j.Level.OFF)
    org.apache.log4j.LogManager.getLogger("org").setLevel(org.apache.log4j.Level.OFF)
    org.apache.log4j.LogManager.getLogger("org.mai").setLevel(org.apache.log4j.Level.INFO)

    logger.info(s"""Starting $appName job""")

    val spark = SparkSession.builder.appName(appName).getOrCreate()
    val df = spark
      .read
      .format("com.databricks.spark.xml")
      .option("rootTag", "users")
      .option("rowTag", "row")
      .load("stackoverflow/Users.xml")

    df.printSchema()

    val displayNames = df.select("DisplayName", "_DisplayName")

    displayNames.foreach(r => logger.info(r.getAs[String]("DisplayName")))

    spark.stop()

    logger.info(s"""$appName job stopped""")
  }

}
